import logging

from storm.monitoring.sensor.api import converter
from storm.monitoring.sensor.api import units

class StringConverter(converter.Converter):

    def __init__(self):
        self.logger = logging.getLogger("storm_sensor.string_converter")
        self.logger.info("creating an instance of StringConverter")

    def do_conversion(self, measure, timestamp):
        self.logger.info("doing conversion")
        string_description = measure.get_description()
        string_unit = units.Units().get_string_unit(measure.get_unit())
        new_value = str(timestamp) + ' '
        new_value += string_description + ' '
        new_value += str(measure.get_value()) + ' '
        new_value += string_unit
        #print new_value
        return new_value
